; HOW TO INSTALL THE PROTOTYPE SEGA SCREEN TO SONIC 1 HIVEBRAIN:
;
; To install the SEGA Screen replace the contents of SEGAScreen to code provide below, from SegaScreen 
; up to (not including) PalCycle_SEGA. Now you need to replace the contents of PalCycle_SEGA to to the
; code provided here (from PalCycle_SEGA to the end of the file). 
;
; You also need to put the segaart.bin file to the "artnem" folder. Lastly, replace Pal_SEGABG with this:
;
Pal_SegaBG:     dc.w 0, $EEE, $EC0, $EA0, $E80, $E60, $E40, $E20, $E00
                dc.w $C00, $A00, $800, $600, 0, 0, 0, 0, 0, 0, 0, 0, 0
                dc.w 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
                dc.w 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
                dc.w 0, 0, 0, 0, 0, 0, 0, 0    
; 
;
; Save the asm file, build it and it should work without any errors. If you have any issues, please do not hesitate to
; let me know
;
; Until next time,
; DeltaWooloo
;
;
; ---------------------------------------------------------------------------
; Sega screen
; ---------------------------------------------------------------------------

SegaScreen:                                  ; CODE XREF: loc_39C↑j
				move.b  #$E0,d0
				bsr.w   PlaySound_Special
                bsr.w   ClearPLC
                bsr.w   Pal_FadeFrom
                lea     ($C00004).l,a6
                move.w  #$8004,(a6)
                move.w  #$8230,(a6)
                move.w  #$8407,(a6)
                move.w  #$8700,(a6)
                move.w  #$8B00,(a6)
                move.w  ($FFFFF60C).w,d0
                andi.b  #$BF,d0
                move.w  d0,($C00004).l

loc_24BC:
				bsr.w	ClearScreen
                move.l  #$40000000,($C00004).l
                lea     (byte_18720).l,a0
                bsr.w   NemDec
				lea	($FF0000).l,a1		; load destination, where to decompress mapping
                lea     (byte_18A56).l,a0
                move.w  #0,d0
                bsr.w   EniDec
				lea	($FF0000).l,a1		; load destination, where to decompress mapping
                move.l  #$461C0003,d0
                moveq   #$B,d1
                moveq   #3,d2
                bsr.w   ShowVDPGraphics
                moveq   #0,d0
                bsr.w   PalLoad2
                move.w  #$28,($FFFFF632).w
                move.w  #0,($FFFFF662).w
                move.w  #0,($FFFFF660).w
                move.w  #$B4,($FFFFF614).w
                move.w  ($FFFFF60C).w,d0
                ori.b   #$40,d0
                move.w  d0,($C00004).l

Loc_2528:                               ; CODE XREF: 00002542↓j
				move.b	#2,($FFFFF62A).w
				bsr.w	DelayProgram	
                bsr.w   PalCycle_SEGA
                tst.w   ($FFFFF614).w
                beq.s   loc_2544
				andi.b	#$80,($FFFFF605).w ; is	Start button pressed?
                beq.s   loc_2528

loc_2544:                               ; CODE XREF: 0000253A↑j
				move.b	#4,($FFFFF600).w	; go to Title Screen
                rts

byte_18720:  incbin   artnem\segaart.bin
		even

byte_18A56:     dc.b 6, 0, 0, 1, 0, 0, $29, 3, $CF, $F, $F8, 0				 		

; ==========================================================================================

PalCycle_SEGA:                               ; CODE XREF: 00002532↓p
                 subq.w  #1,($FFFFF634).w
                 bpl.s   locret_1A68
                 move.w  #3,($FFFFF634).w
                 move.w  ($FFFFF632).w,d0
                 bmi.s   locret_1A68
                 subq.w  #2,($FFFFF632).w
                 lea     (word_1A6A).l,a0
                 lea     ($FFFFFB04).w,a1
                 adda.w  d0,a0
                 move.l  (a0)+,(a1)+
                 move.l  (a0)+,(a1)+
                 move.l  (a0)+,(a1)+
                 move.l  (a0)+,(a1)+
                 move.l  (a0)+,(a1)+
                 move.w  (a0)+,(a1)+

locret_1A68:                            ; CODE XREF: sub_1A3A+4↑j
			rts								; sub_1A3A+10↑j
; End of function PalCycle_SEGA	

word_1A6A:     	 dc.w $EC0, $EA0, $E80, $E60, $E40, $E20, $E00, $C00, $A00
                 dc.w $800, $600, $800, $A00, $C00, $E00, $E20, $E40, $E60
                 dc.w $E80, $EA0, $EC0, $EA0, $E80, $E60, $E40, $E20, $E00
                 dc.w $C00, $A00, $800, $600
					 
; ===========================================================================